%ZETA_DOMAIN Z-shaped quasi-structured grid generator
%
% Grid defining data saved to the file: zeta_grid_struct.mat
%
%   TIFISS scriptfile: AB; 07 June 2017.
% Copyright (c) 2017 A. Bespalov, L. Rocchi
%
%
% NOTE
% -------------------------------------------------------------------------
% The mesh is quasi-structured because of the presence of two "non-regular" 
% elements in the bottom-left corner needed to avoid an element with two 
% boundary edges


  global slope   % needed for final plot
  slope = 1;

  fprintf('Quasi-structured mesh for "pure" Z-shaped domain\n');
  
% Vertices map
  xy = [-1.0000   -1.0000; ...
        -0.5000   -1.0000; ...
              0   -1.0000; ...
         0.5000   -1.0000; ...
         1.0000   -1.0000; ...
        -0.5000   -0.7500; ...
        -0.2500   -0.7500; ...
        -0.5000   -0.5000; ...
              0   -0.5000; ...
         0.5000   -0.5000; ...
         1.0000   -0.5000; ...
        -1.0000    0.0000; ...
        -0.5000    0.0000; ...
            0.0    0.0000; ...
         0.5000    0.0000; ...
         1.0000    0.0000; ...
        -1.0000    0.5000; ...
        -0.5000    0.5000; ...
            0.0    0.5000; ...
         0.5000    0.5000; ...
         1.0000    0.5000; ...
        -1.0000    1.0000; ...
        -0.5000    1.0000; ...
              0    1.0000; ...
         0.5000    1.0000; ...
         1.0000    1.0000]; 
              
% Elements map
  evt = [ 1     6     8; ...
          1     2     6; ...
          7     6     2; ...
          8     6     7; ...
          3     7     2; ...
          9     7     3; ...
          8     7     9; ...
          8     9    14; ...
         10     9     3; ...
          3     4    10; ...
         10     4     5; ...
          5    11    10; ...
         10    11    16; ...
         16    15    10; ...
         10    15    14; ...
         14     9    10; ...       
         18    17    12; ...
         12    13    18; ...
         18    13    14; ...
         14    19    18; ...
         18    19    24; ...
         24    23    18; ...
         18    23    22; ...
         22    17    18; ...       
         20    19    14; ...
         14    15    20; ...
         20    15    16; ...
         16    21    20; ...
         20    21    26; ...
         26    25    20; ...
         20    25    24; ...
         24    19    20];     


% Get boundary nodes and edges
  [eboundt,bound] = find_boundary_elements(evt);

% % Total nodes and interior nodes
%   totalnodes = 1:size(xy,1);
%   intnodes = totalnodes(~ismember(totalnodes,bound));  
%   plot_mesh(evt,xy,'',1,1,intnodes,bound);
%   pause

% Save data
  gohome
  cd datafiles
  save zeta_grid_struct.mat xy evt bound eboundt 
