%HELPME_OCTAVE  Octave specific issues 
%   TIFISS scriptfile: DJS; 14 August 2019
% Copyright (c) 2019 D.J. Silvester, A. Bespalov

fprintf(' \n');
fprintf(' TIFISS Version 1.2 \n')
fprintf(' The Octave package is essentially identical to the MATLAB package\n');
fprintf(' The exceptions to this rule are\n')
fprintf('    o the distmesh mesh generation functionality is not included\n');
fprintf('    o the diffproblemdemo is tailored accordingly\n');
fprintf('    o contour plots of the estimated error are not shown\n');
fprintf(' \n');
fprintf(' Here is a list of minor issues with the Octave 5.1 implementation\n');
fprintf(' *  Refinement options 2 and 3 give different results to those in MATLAB:\n');
fprintf('    ("stable" is not available when calling "unique" in Octave)\n');
fprintf(' *  The screen output from the testproblem files looks different \n');
fprintf('    (text emphasis <strong> is not yet implemented in Octave)\n');
fprintf(' *  Some of the solver options give different results to those in MATLAB:\n');
fprintf('    (no "minres" in Octave)\n');
fprintf(' *  The default "pause" (press a key) is hard coded within the \n')
fprintf('    helpme and demo files: otherwise the command window freezes\n');
fprintf(' *  The nondefault setting "more off" is preset in setpath.m: otherwise\n')
fprintf('    screen and the graphical output are NOT synchronised correctly\n');
fprintf(' *  The graphical output is slightly different: \n');
fprintf('    o default colormap is "viridis" \n');
fprintf('    o interpetation of TeX symbols in labels/legends is not well defined\n');
fprintf(' \n');
fprintf(' See/type "octavefiles.txt" for a list of the modified functions\n')
fprintf(' \n');
fprintf(' Please report any other compatibility problems that you encounter\n') 
fprintf(' to the Octave Bug Report website.\n\n');
